/**
   @version 1.20 2004-09-11
   @author Cay Horstmann
*/

import java.io.*;
import java.security.*;
import java.util.*;

/**
   Menedżer bezpieczeństwa nadzorujący operacje odczytu plików.
*/
public class WordCheckSecurityManager extends SecurityManager
{  
   public void checkPermission(Permission p)
   {  
      if (p instanceof FilePermission && p.getActions().equals("read"))
      {  
         if (inSameManager())
            return;
         String fileName = p.getName();
         if (containsBadWords(fileName))
            throw new SecurityException("Bad words in " + fileName);
      }
      else super.checkPermission(p);
   }

   /**
      Zwraca wartość true, jeśli menedżer został wywołany
      podczas innego jego wywołania.
      @return wartość true, jeśli menedżer został wywołany wielokrotnie
   */
   public boolean inSameManager()
   {  
      Class[] cc = getClassContext();

      // pomija bieżący zbiór wywołań menedżera
      int i = 0;
      while (i < cc.length && cc[0] == cc[i])
         i++;

      // i sprawdza czy istnieją jeszcze inne
      while (i < cc.length)
      {  
         if (cc[0] == cc[i]) return true;
         i++;
      }
      return false;
   }

   /**
      Sprawdza, czy plik zawiera zabronione słowa.
      @param fileName nazwa pliku
      @return wartość true, jeśli nazwa pliku posiada rozszerzenie .txt 
      i plik zawiera co najmniej jedno zabronione słowo.
   */
   boolean containsBadWords(String fileName)
   {  
      if (!fileName.toLowerCase().endsWith(".txt")) return false;
         // sprawdza wyłącznie pliki tekstowe
      Scanner in; 
      try
      {
         in = new Scanner(new FileReader(fileName));
      }
      catch (IOException e)
      {
         return false;
      }
      while (in.hasNext())
         if (badWords.contains(in.next().toLowerCase()))
         {
            in.close();
            System.out.println(fileName);
            return true;
         }
      return false;
   }

   private List badWords = Arrays.asList(new String[] { "sex", "drugs", "c++" });
}
